import { TPromise } from '@vscode/base-node/vs/base/common/winjs.base';
import Event from '@vscode/base-node/vs/base/common/event';
export interface ShutdownEvent {
    veto(value: boolean | TPromise<boolean>): void;
    reason: ShutdownReason;
    payload?: object;
}
export declare enum ShutdownReason {
    CLOSE = 0,
    QUIT = 1,
    RELOAD = 2,
    LOAD = 3,
}
export declare enum StartupKind {
    NewWindow = 1,
    ReloadedWindow = 3,
    ReopenedWindow = 4,
}
export declare enum LifecyclePhase {
    Starting = 1,
    Restoring = 2,
    Running = 3,
    Eventually = 4,
}
export interface ILifecycleService {
    readonly startupKind: StartupKind;
    readonly phase: LifecyclePhase;
    when(phase: LifecyclePhase): Promise<void>;
    readonly onWillShutdown: Event<ShutdownEvent>;
    readonly onShutdown: Event<ShutdownReason>;
}
export declare const NullLifecycleService: ILifecycleService;
